! WHIZARD 3.1.2.1 Mar 21 2023
!
! Copyright (C) 1999-2023 by
!     Wolfgang Kilian <kilian@physik.uni-siegen.de>
!     Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
!     Juergen Reuter <juergen.reuter@desy.de>
!
!     with contributions from
!     cf. main AUTHORS file
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This file has been stripped of most comments.  For documentation, refer
! to the source 'whizard.nw'

module iterator_uti

  use iterator

  implicit none
  private

public :: iterator_1

 contains

subroutine iterator_1 (u)
  integer, intent(in) :: u
  type(iterator_t) :: iter

  write (u, "(A)") "* Test output: iterator_1"
  write (u, "(A)") "*   Purpose: test interface and implementation of the forward integer iterator"
  write (u, "(A)")

  call iter%init (1, 10)
  call iter%write (u)
  do while (iter%is_iterable ())
     write (u, "(A,1X,I3)") "NDX", iter%next ()
  end do

  call iter%init (10, 1, -1)
  call iter%write (u)
  do while (iter%is_iterable ())
     write (u, "(A,1X,I3)") "NDX", iter%next ()
  end do
  write (u, "(A,1X,I3)") "INVALID NDX", iter%next ()

  call iter%init (1, 10)
  call iter%write (u)
  do while (iter%is_iterable ())
     call iter%next_step ()
     write (u, "(A)") "STEP."
  end do
end subroutine iterator_1

end module iterator_uti
