! WHIZARD 3.1.2.1 Mar 21 2023
!
! Copyright (C) 1999-2023 by
!     Wolfgang Kilian <kilian@physik.uni-siegen.de>
!     Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
!     Juergen Reuter <juergen.reuter@desy.de>
!
!     with contributions from
!     cf. main AUTHORS file
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This file has been stripped of most comments.  For documentation, refer
! to the source 'whizard.nw'

module kinematics_vars_uti

  use kinds, only: default
  use kinematics_vars

  implicit none
  private

  public :: kinematics_vars_1

contains

  subroutine kinematics_vars_1 (u)
    integer, intent(in) :: u
    real(default) :: Easq, Ebsq
    real(default) :: ma, mb, mn
    real(default) :: pmissx, pmissy
    real(default) :: mt2_b, scale
    real(default) :: pax, pay, pbx, pby
    type(mt2_t) :: mt2

    write (u, "(A)")  "* Test output: mt2_1"
    write (u, "(A)")  "*   Purpose: calculate MT2 for the massive case"
    write (u, "(A)")
    
    call mt2_setevent (mn, ma, mb, Easq, Ebsq, pax, pay, pbx, pby, &
         pmissx, pmissy, scale, u)
    call mt2_init (mt2, mn, ma, mb, Easq, Ebsq, pax, pay, pbx, pby, &
         pmissx, pmissy, scale)
    call write_mt2_input (mt2, u)
    call mt2calc (mt2, mn, mt2_b)
    call write_mt2_output (mt2_b, scale, u)
  end subroutine kinematics_vars_1


end module kinematics_vars_uti
