! WHIZARD <<Version>> <<Date>>
! 
! Copyright (C) 1999-2023 by 
!     Wolfgang Kilian <kilian@physik.uni-siegen.de>
!     Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
!     Juergen Reuter <juergen.reuter@desy.de>
!     with contributions from
!     cf. main AUTHORS file
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module system_dependencies

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! All character strings indented by 7 blanks will be automatically
  ! split into chunks respecting the FORTRAN line length constraint by
  ! configure.
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  

  implicit none
  public
 
  ! Program version
  character(*), parameter :: WHIZARD_VERSION = "3.1.2.1"
  character(*), parameter :: WHIZARD_DATE = "Mar 21 2023"

  ! System paths
  ! These are used for testing without existing installation
  character(*), parameter :: WHIZARD_TEST_BASICS_MODPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/basics"
  character(*), parameter :: WHIZARD_TEST_UTILITIES_MODPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/utilities"
  character(*), parameter :: WHIZARD_TEST_COMBINATORICS_MODPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/combinatorics"
  character(*), parameter :: WHIZARD_TEST_SYSTEM_MODPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/system"
  character(*), parameter :: WHIZARD_TEST_PHYSICS_MODPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/physics"
  character(*), parameter :: WHIZARD_TEST_ME_MODPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/matrix_elements"
  character(*), parameter :: WHIZARD_TEST_MODELS_MODPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/models"
  character(*), parameter :: WHIZARD_TEST_THRESHOLD_MODPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/threshold"
  character(*), parameter :: WHIZARD_TEST_OMEGA_MODPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/omega/src"
  character(*), parameter :: WHIZARD_TEST_MAIN_LIBPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/main"
  character(*), parameter :: WHIZARD_TEST_OMEGA_BINPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/omega/bin"
  character(*), parameter :: WHIZARD_TEST_SRC_LIBPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src"
  character(*), parameter :: WHIZARD_TEST_HEPMC_LIBPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/hepmc"
  character(*), parameter :: WHIZARD_TEST_LCIO_LIBPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/lcio"
  character(*), parameter :: WHIZARD_TEST_HOPPET_LIBPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/hoppet"
  character(*), parameter :: WHIZARD_TEST_LOOPTOOLS_LIBPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/looptools"
  character(*), parameter :: WHIZARD_TEST_MODELPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/share/models"
  character(*), parameter :: WHIZARD_TEST_MODELPATH_UFO = &
       "/scratch/reuter/local/packages/whizard/trunk/share/models/UFO"
  character(*), parameter :: WHIZARD_TEST_MODELS_LIBPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/models"
  character(*), parameter :: WHIZARD_TEST_SUSYPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/share/susy"
  character(*), parameter :: WHIZARD_TEST_GMLPATH= &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/src/gamelan"
  character(*), parameter :: WHIZARD_TEST_CUTSPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/share/cuts"
  character(*), parameter :: WHIZARD_TEST_SHAREPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/share"
  character(*), parameter :: WHIZARD_TEST_TESTDATAPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/share/test"
  character(*), parameter :: WHIZARD_TEST_TEXPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/src/feynmf"
  character(*), parameter :: WHIZARD_TEST_CIRCE2PATH = &
       "/scratch/reuter/local/packages/whizard/trunk/circe2/share/data"
  character(*), parameter :: WHIZARD_TEST_BEAMSIMPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/share/beam-sim"
  character(*), parameter :: WHIZARD_TEST_MULIPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/share/muli"
  character(*), parameter :: PDF_BUILTIN_TEST_DATAPATH = &
       "/scratch/reuter/local/packages/whizard/trunk/share/pdf_builtin"

  ! WHIZARD-specific include flags
  character(*), parameter :: WHIZARD_TEST_INCLUDES = &
       "-I" // WHIZARD_TEST_MODELS_MODPATH // " " // &
       "-I" // WHIZARD_TEST_THRESHOLD_MODPATH // " " // &
       "-I" // WHIZARD_TEST_OMEGA_MODPATH // " " // &
       "-I" // WHIZARD_TEST_ME_MODPATH // " " // &
       "-I" // WHIZARD_TEST_PHYSICS_MODPATH // " " // &
       "-I" // WHIZARD_TEST_SYSTEM_MODPATH // " " // &
       "-I" // WHIZARD_TEST_COMBINATORICS_MODPATH // " " // &
       "-I" // WHIZARD_TEST_UTILITIES_MODPATH // " " // &
       "-I" // WHIZARD_TEST_BASICS_MODPATH // " " // &
       "-I/home/reuter/local/packages/openloops/lib_src/openloops/mod " 

  ! WHIZARD-specific link flags
  character(*), parameter :: WHIZARD_TEST_LDFLAGS = &
       "-L" // WHIZARD_TEST_MAIN_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_SRC_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_HEPMC_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_LCIO_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_HOPPET_LIBPATH // " " // &
       "-L" // WHIZARD_TEST_LOOPTOOLS_LIBPATH // " " // &
       "-lwhizard_main -lwhizard -lomega " // &
       "-I/usr/include/tirpc -ltirpc " // &
       "-Wl,-rpath,/home/reuter/local/lib -L/home/reuter/local/lib &
       & -Wl,-rpath,/home/reuter/local/lib -L/home/reuter/local/lib"

  ! Libtool
  character(*), parameter :: WHIZARD_LIBTOOL_TEST = &
       "/scratch/reuter/local/packages/whizard/trunk/_build_debug/libtool"

  ! System paths
  ! These are used for the installed version
  character(*), parameter :: PREFIX = &
       "/scratch/reuter/local/packages/whizard/trunk/_inst_debug"
  character(*), parameter :: EXEC_PREFIX = &
       "${prefix}"
  character(*), parameter :: BINDIR = &
       "${exec_prefix}/bin"
  character(*), parameter :: LIBDIR = &
       "${exec_prefix}/lib"
  character(*), parameter :: INCLUDEDIR = &
       "${prefix}/include"
  character(*), parameter :: DATAROOTDIR = &
       "${prefix}/share"
  character(*), parameter :: FMODDIR = &
       "/scratch/reuter/local/packages/whizard/trunk/_inst_debug/lib/mod"

  character(*), parameter :: PKGLIBDIR = LIBDIR  // "/whizard"
  character(*), parameter :: PKGDATADIR = DATAROOTDIR // "/whizard"
  character(*), parameter :: PKGTEXDIR = DATAROOTDIR // "/texmf/whizard"
  character(*), parameter :: PKGCIRCE2DIR = DATAROOTDIR // "/circe2"

  character(*), parameter :: WHIZARD_MODPATH = &
       FMODDIR // "/whizard"
  character(*), parameter :: OMEGA_MODPATH = &
       FMODDIR // "/omega"
  character(*), parameter :: MODELS_MODPATH = &
       FMODDIR // "/models"
  character(*), parameter :: WHIZARD_OMEGA_BINPATH = &
       BINDIR
  character(*), parameter :: WHIZARD_OMEGA_LIBPATH = &
       LIBDIR
  character(*), parameter :: WHIZARD_MODELPATH = &
       PKGDATADIR // "/models"
  character(*), parameter :: WHIZARD_MODELPATH_UFO = &
       PKGDATADIR // "/models/UFO"
  character(*), parameter :: WHIZARD_MODELS_LIBPATH = &
       PKGLIBDIR // "/models"
  character(*), parameter :: WHIZARD_SUSYPATH = &
       PKGDATADIR // "/susy"
  character(*), parameter :: WHIZARD_GMLPATH= &
       PKGLIBDIR // "/gamelan"
  character(*), parameter :: WHIZARD_SHAREPATH = &
       PKGDATADIR
  character(*), parameter :: WHIZARD_TESTDATAPATH = &
       PKGDATADIR // "/test"
  character(*), parameter :: WHIZARD_CUTSPATH = &
       PKGDATADIR // "/cuts"
  character(*), parameter :: WHIZARD_TEXPATH = &
       PKGTEXDIR
  character(*), parameter :: WHIZARD_CIRCE2PATH = &
       PKGCIRCE2DIR // "/data"
  character(*), parameter :: WHIZARD_BEAMSIMPATH = &
       PKGDATADIR // "/beam-sim"
  character(*), parameter :: WHIZARD_MULIPATH = &
       PKGDATADIR // "/muli"
  character(*), parameter :: PDF_BUILTIN_DATAPATH = &
       PKGDATADIR // "/pdf_builtin"

  ! WHIZARD-specific include flags
  character(*), parameter :: WHIZARD_INCLUDES = &
      "-I" // WHIZARD_MODPATH // " " // &
      "-I" // OMEGA_MODPATH // " " // &
      "-I" // MODELS_MODPATH // " " // &
       "-I/home/reuter/local/packages/openloops/lib_src/openloops/mod "

  ! WHIZARD-specific link flags
  character(*), parameter :: WHIZARD_LDFLAGS = &
      "-L" // WHIZARD_OMEGA_LIBPATH // " " // &
      "-lwhizard_main -lwhizard -lomega " // &
       "-I/usr/include/tirpc -ltirpc "

  ! Libtool
  character(*), parameter :: WHIZARD_LIBTOOL = &
      PKGLIBDIR // "/libtool"


  ! Fortran compiler
  character(*), parameter :: DEFAULT_FC = &
       "gfortran"
  character(*), parameter :: DEFAULT_FCFLAGS = &
       "   -g -O2"
  character(*), parameter :: DEFAULT_FCFLAGS_PIC = &
       " -fPIC"
  character(*), parameter :: DEFAULT_FC_SRC_EXT = &
       ".f90"
  character(*), parameter :: DEFAULT_FC_PRECISION = &
       "double"
  character(*), parameter :: FCLIBS = &
       " -L/scratch/reuter/local/lib/gcc/x86_64-pc-linux-gnu/14.0.0 -L/scratch/reuter/local/lib/gcc/x86_64-pc-l&
       &inux-gnu/14.0.0/../../../../lib64 -L/lib/x86_64-linux-gnu -L/lib/../lib64 -L/usr/lib/x86_64-linux-gnu -L/usr/li&
       &b/../lib64 -L/scratch/reuter/local/lib/gcc/x86_64-pc-linux-gnu/14.0.0/../../.. -lgfortran -lm -lquadmath"

  logical, parameter      :: OS_IS_DARWIN = .false.
  
  ! C compiler
  character(*), parameter :: DEFAULT_CC = &
       "gcc"
  character(*), parameter :: DEFAULT_CFLAGS = &
       "-g -O2"
  character(*), parameter :: DEFAULT_CFLAGS_PIC = &
       ""
  logical, parameter :: CC_IS_GNU = .true.
  logical, parameter :: CC_HAS_QUADMATH = .true.

  ! C++ compiler
  character(*), parameter :: DEFAULT_CXX = &
       "g++"
  character(*), parameter :: DEFAULT_CXXFLAGS = &
       "-g -O2"
  character(*), parameter :: DEFAULT_CXXLIBS = &
       " -L/scratch/reuter/local/lib/gcc/x86_64-pc-linux-gnu/14.0.0 -L/scratch/reuter/local/lib/gcc/x86_64-pc-l&
       &inux-gnu/14.0.0/../../../../lib64 -L/lib/x86_64-linux-gnu -L/lib/../lib64 -L/usr/lib/x86_64-linux-gnu -L/usr/li&
       &b/../lib64 -L/scratch/reuter/local/lib/gcc/x86_64-pc-linux-gnu/14.0.0/../../.. -lstdc++ -lm -lgcc_s"

  ! Object files
  character(*), parameter :: DEFAULT_OBJ_EXT = &
       ".o"

  ! Linker
  character(*), parameter :: DEFAULT_LD = &
       "/usr/bin/ld -m elf_x86_64"
  character(*), parameter :: DEFAULT_LDFLAGS = &
       ""
  character(*), parameter :: DEFAULT_LDFLAGS_SO = "-shared"
  character(*), parameter :: DEFAULT_LDFLAGS_STATIC = &
       "-lstdc++ -I/usr/include/tirpc -ltirpc"
  character(*), parameter :: DEFAULT_LDFLAGS_HEPMC = &
       ""
  character(*), parameter :: DEFAULT_LDFLAGS_LCIO = &
       ""
  character(*), parameter :: DEFAULT_LDFLAGS_HOPPET = &
       ""
  character(*), parameter :: DEFAULT_LDFLAGS_LOOPTOOLS = &
       ""
  character(*), parameter :: DEFAULT_SHRLIB_EXT = "so"
  character(*), parameter :: DEFAULT_FC_SHRLIB_EXT = "so"

  ! Pack/unpack
  character(*), parameter :: DEFAULT_PACK_CMD = "tar -czf"
  character(*), parameter :: DEFAULT_UNPACK_CMD = "tar -xzf"
  character(*), parameter :: DEFAULT_PACK_EXT = ".tgz"

  ! Make
  character(*), parameter :: DEFAULT_MAKEFLAGS = &
       "-j1"

  ! LHAPDF library
  character(*), parameter :: LHAPDF_PDFSETS_PATH = &
       "/home/reuter/local/share/LHAPDF"

  ! Available methods for event analysis display
  character(*), parameter :: EVENT_ANALYSIS = &
       "yes"
  character(*), parameter :: EVENT_ANALYSIS_PS = &
       "yes"
  character(*), parameter :: EVENT_ANALYSIS_PDF = &
       "yes"

  ! Programs used for event analysis display
  character(*), parameter :: PRG_LATEX  = &
       "latex"
  character(*), parameter :: PRG_MPOST  = &
       "mpost"
  character(*), parameter :: PRG_DVIPS  = &
       "dvips"
  character(*), parameter :: PRG_PS2PDF = &
       "ps2pdf14"

  ! Programs and libraries used for NLO calculations
  ! GoSam
  character(*), parameter :: GOSAM_DIR = &
       ""
  character(*), parameter :: GOLEM_DIR = &
       ""
  character(*), parameter :: FORM_DIR = &
       ""
  character(*), parameter :: QGRAF_DIR = &
       ""
  character(*), parameter :: NINJA_DIR = &
       ""
  character(*), parameter :: SAMURAI_DIR = &
       ""

  ! OpenLoops
  character(*), parameter :: OPENLOOPS_DIR = &
       "/home/reuter/local/packages/openloops"
  character(*), parameter :: RECOLA_DIR = &
       ""  

  ! Hardwired options for batch-mode processing
  character(*), parameter :: OPT_LATEX  = &
       "-halt-on-error"
  character(*), parameter :: OPT_MPOST  = &
       "--math=scaled -halt-on-error"

  ! dlopen parameters
  integer, parameter :: &
     RTLD_LAZY   = 1 , &
     RTLD_NOW    = 2 , &
     RTLD_GLOBAL = 256 , &
     RTLD_LOCAL  = 0

  ! Misc
  logical, parameter :: MPOST_AVAILABLE = .true.

  logical, parameter :: LHAPDF5_AVAILABLE = .false.
  logical, parameter :: LHAPDF6_AVAILABLE = .true.
  logical, parameter :: HEPMC2_AVAILABLE = .false.
  logical, parameter :: HEPMC3_AVAILABLE = .false.
  logical, parameter :: LCIO_AVAILABLE = "no" == "yes"
  logical, parameter :: HOPPET_AVAILABLE = .false.

  logical, parameter :: PYTHIA6_AVAILABLE = .true.
  logical, parameter :: PYTHIA8_AVAILABLE = .false.

  logical, parameter :: GOSAM_AVAILABLE = .false.
  logical, parameter :: OPENLOOPS_AVAILABLE = .false.
  logical, parameter :: RECOLA_AVAILABLE = .false.  

contains

  ! Subroutines that depend on configure settings

  ! OpenMP wrapper routines, work independent of OpenMP status
  function openmp_is_active () result (flag)
    logical :: flag
!    flag = .true.
    flag = .false.
  end function openmp_is_active

  subroutine openmp_set_num_threads (num)
    integer, intent(in) :: num
!    call omp_set_num_threads (num)
  end subroutine openmp_set_num_threads
  
  function openmp_get_num_threads () result (num)
    integer :: num
!    num = omp_get_num_threads ()
    num = 1
  end function openmp_get_num_threads
  
  function openmp_get_max_threads () result (num)
    integer :: num
!    num = omp_get_max_threads ()
    num = 1
  end function openmp_get_max_threads
  
  function openmp_get_default_max_threads () result (num)
    integer :: num
    num = 1
  end function openmp_get_default_max_threads

end module system_dependencies
